part of openrqm.api;

class RQMWorkspace {
  
  int id = null;
  
  String name = null;
  
  int workspaceId = null;
  
  List<RQMWorkspace> workspaces = [];
  
  List<RQMDocument> documents = [];
  RQMWorkspace();

  @override
  String toString() {
    return 'RQMWorkspace[id=$id, name=$name, workspaceId=$workspaceId, workspaces=$workspaces, documents=$documents, ]';
  }

  RQMWorkspace.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    id = json['id'];
    name = json['name'];
    workspaceId = json['workspace_id'];
    workspaces = (json['workspaces'] == null) ?
      null :
      RQMWorkspace.listFromJson(json['workspaces']);
    documents = (json['documents'] == null) ?
      null :
      RQMDocument.listFromJson(json['documents']);
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (id != null)
      json['id'] = id;
    if (name != null)
      json['name'] = name;
    if (workspaceId != null)
      json['workspace_id'] = workspaceId;
    if (workspaces != null)
      json['workspaces'] = workspaces;
    if (documents != null)
      json['documents'] = documents;
    return json;
  }

  static List<RQMWorkspace> listFromJson(List<dynamic> json) {
    return json == null ? List<RQMWorkspace>() : json.map((value) => RQMWorkspace.fromJson(value)).toList();
  }

  static Map<String, RQMWorkspace> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, RQMWorkspace>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = RQMWorkspace.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of RQMWorkspace-objects as value to a dart map
  static Map<String, List<RQMWorkspace>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<RQMWorkspace>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = RQMWorkspace.listFromJson(value);
       });
     }
     return map;
  }
}

